
/// Html tags.
library html;

import 'dart:html';
export 'dart:html';
import 'builder.dart';

final Tag a         = ([Build b]) => build(() => new AnchorElement(), b);
final Tag area      = ([Build b]) => build(() => new AreaElement(), b);
final Tag b         = ([Build b]) => build(() => _element('b'), b);
final Tag base      = ([Build b]) => build(() => new BaseElement(), b);
final Tag body      = ([Build b]) => build(() => new BodyElement(), b);
final Tag br        = ([Build b]) => build(() => new BRElement(), b);
final Tag button    = ([Build b]) => build(() => new ButtonElement(), b);
final Tag canvas    = ([Build b]) => build(() => new CanvasElement(), b);
final Tag caption   = ([Build b]) => build(() => new TableCaptionElement(), b);
final Tag col       = ([Build b]) => build(() => new TableColElement(), b);
final Tag content   = ([Build b]) => build(() => new ContentElement(), b);
final Tag datalist  = ([Build b]) => build(() => new DataListElement(), b);
final Tag dd        = ([Build b]) => build(() => _element('dd'), b);
final Tag details   = ([Build b]) => build(() => new DetailsElement(), b);
final Tag div       = ([Build b]) => build(() => new DivElement(), b);
final Tag dl        = ([Build b]) => build(() => _element('dl'), b);
final Tag dt        = ([Build b]) => build(() => _element('dt'), b);
final Tag embed     = ([Build b]) => build(() => new EmbedElement(), b);
final Tag fieldset  = ([Build b]) => build(() => new FieldSetElement(), b);
final Tag form      = ([Build b]) => build(() => new FormElement(), b);
final Tag h1        = ([Build b]) => build(() => new HeadingElement.h1(), b);
final Tag h2        = ([Build b]) => build(() => new HeadingElement.h2(), b);
final Tag h3        = ([Build b]) => build(() => new HeadingElement.h3(), b);
final Tag h4        = ([Build b]) => build(() => new HeadingElement.h4(), b);
final Tag h5        = ([Build b]) => build(() => new HeadingElement.h5(), b);
final Tag h6        = ([Build b]) => build(() => new HeadingElement.h6(), b);
final Tag head      = ([Build b]) => build(() => new HeadElement(), b);
final Tag hr        = ([Build b]) => build(() => new HRElement(), b);
final Tag html      = ([Build b]) => build(() => new HtmlElement(), b);
final Tag i         = ([Build b]) => build(() => _element('i'), b);
final Tag img       = ([Build b]) => build(() => new ImageElement(), b);
final Tag input     = ([Build b]) => build(() => new InputElement(), b);
final Tag keygen    = ([Build b]) => build(() => new KeygenElement(), b);
final Tag label     = ([Build b]) => build(() => new LabelElement(), b);
final Tag legend    = ([Build b]) => build(() => new LegendElement(), b);
final Tag li        = ([Build b]) => build(() => new LIElement(), b);
final Tag link      = ([Build b]) => build(() => new LinkElement(), b);
final Tag map       = ([Build b]) => build(() => new MapElement(), b);
final Tag menu      = ([Build b]) => build(() => new MenuElement(), b);
final Tag meter     = ([Build b]) => build(() => new MeterElement(), b);
final Tag object    = ([Build b]) => build(() => new ObjectElement(), b);
final Tag ol        = ([Build b]) => build(() => new OListElement(), b);
final Tag optgroup  = ([Build b]) => build(() => new OptGroupElement(), b);
final Tag option    = ([Build b]) => build(() => new OptionElement(), b);
final Tag output    = ([Build b]) => build(() => new OutputElement(), b);
final Tag p         = ([Build b]) => build(() => new ParagraphElement(), b);
final Tag param     = ([Build b]) => build(() => new ParamElement(), b);
final Tag pre       = ([Build b]) => build(() => new PreElement(), b);
final Tag progress  = ([Build b]) => build(() => new ProgressElement(), b);
final Tag script    = ([Build b]) => build(() => new ScriptElement(), b);
final Tag select    = ([Build b]) => build(() => new SelectElement(), b);
final Tag source    = ([Build b]) => build(() => new SourceElement(), b);
final Tag span      = ([Build b]) => build(() => new SpanElement(), b);
final Tag style     = ([Build b]) => build(() => new StyleElement(), b);
final Tag table     = ([Build b]) => build(() => new TableElement(), b);
final Tag tbody     = ([Build b]) => build(() => _element('tbody'), b);
final Tag td        = ([Build b]) => build(() => new TableCellElement(), b);
final Tag textarea  = ([Build b]) => build(() => new TextAreaElement(), b);
final Tag tfoot     = ([Build b]) => build(() => _element('tfoot'), b);
final Tag th        = ([Build b]) => build(() => _element('th'), b);
final Tag thead     = ([Build b]) => build(() => _element('thead'), b);
final Tag title     = ([Build b]) => build(() => new TitleElement(), b);
final Tag tr        = ([Build b]) => build(() => new TableRowElement(), b);
final Tag track     = ([Build b]) => build(() => new TrackElement(), b);
final Tag u         = ([Build b]) => build(() => _element('u'), b);
final Tag ul        = ([Build b]) => build(() => new UListElement(), b);
final Tag video     = ([Build b]) => build(() => new VideoElement(), b);

/// Append the given [text] as a text node to the current [host].
///
/// This function may only be called from inside a [Build] function.
void text(String text) {
  final _host = host;
  if (_host == null) 
    throw new StateError('text(...) may only be called from a Build function.');
  _host.appendText(text);
}

// Create an Element for a `tag` that is untyped in `dart:html`.  E.g. `<th>`
Element _element(String tag) {
  if (!Element.isTagSupported(tag)) throw new UnsupportedError(tag);
  return new Element.tag(tag);
}
