
part of custom;

/// A stateful button that allows toggling between an [up] and a [down] state.
class ToggleButton implements HasElement {
  final Element element = button();
  final ContentElement _content = content()..select='.up';  
  /// An observable stream of this button's state transitions.
  /// A _true_ value represents [down] and a _false_ value represents [up].
  final _states = new StreamController<bool>();
  Stream<bool> get states => _states.stream;
  bool _down = false;
  /// Whether or not this button is down.
  bool get down => _down;
       set down(bool value) {
         if (value != _down) {
           _down = value;           
           if (_down) _content.select = '.down';
           else _content.select = '.up';
           _states.add(_down);
         }
       }
  /// Whether or not this button is up.
  bool get up => !_down;
  /// Constructs a new toggle button.  
  ToggleButton() {
    element.xtag = this;
    element.onClick.listen((event) => down = !_down);
    element.createShadowRoot().append(_content);    
  }
}
